Package com.treemap.swing.treeplot

# Class SwingTreePlotToolTip<N,Row,Column>

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
com.treemap.swing.treeplot.SwingTreePlotToolTip<N,Row,Column>

Type Parameters:
  `N` -

All Implemented Interfaces:
  `TreeMapToolTip<N,Row,Column,Color,Font>`, `ImageObserver`, `MenuContainer`, `Serializable`

public class SwingTreePlotToolTip<N,Row,Column> extends JComponent implements TreeMapToolTip<N,Row,Column,Color,Font>
Default implementation of a tooltip using JidePopup as a container.

See Also:
  - Serialized Form

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `protected class`
  `SwingTreePlotToolTip.MouseRedispatcher`

  ## Nested classes/interfaces inherited from class javax.swing.JComponent

  `JComponent.AccessibleJComponent`

  ## Nested classes/interfaces inherited from class java.awt.Container

  `Container.AccessibleAWTContainer`

  ## Nested classes/interfaces inherited from class java.awt.Component

  `Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

  ## Nested classes/interfaces inherited from interface com.treemap.TreeMapToolTip

  `TreeMapToolTip.ToolTipType`

- ## Field Summary

  ### Fields inherited from class javax.swing.JComponent

  `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

  ### Fields inherited from class java.awt.Component

  `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

  ### Fields inherited from interface java.awt.image.ImageObserver

  `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SwingTreePlotToolTip(SwingTreePlotView<N,Row,Column> view)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected TreeMapPopup`
  `createPopup()`
  Creates a popup.
  `Border`
  `getBorder()`
  `protected com.macrofocus.igraphics.CPColor<Color>`
  `getBorderColor()`
  `Insets`
  `getInsets()`
  `Component`
  `getNativeComponent()`
  `N`
  `getNode()`
  Gets the current node that the tooltip should display information about.
  `TreeMapPopup`
  `getPopup()`
  Gets the popup or create one if one doesn't exist yet.
  `com.macrofocus.geom.Point`
  `getPopupLocation()`
  `com.macrofocus.geom.Point`
  `getPreferredLocation()`
  Gets the preferred location of the tooltip relative to the TreeMapView.
  `com.macrofocus.geom.Point`
  `getPreferredLocation(com.macrofocus.geom.Point p)`
  Gets the preferred location of the tooltip relative to the TreeMapView.
  `Dimension`
  `getPreferredSize(TGraphics<Color,Font> g)`
  `int`
  `getPreferredWidth()`
  Gets the preferred width of the tooltip.
  `ToolTipTreePlotRenderer`
  `getRenderer()`
  `TreeMapToolTip.ToolTipType`
  `getType()`
  Gets the type of tooltip.
  `protected SwingTreePlotView<N,Row,Column>`
  `getView()`
  Gets the view associated with this tooltip.
  `protected void`
  `hidePopup()`
  Hides the popup.
  `void`
  `paintBackground(TGraphics<Color,Font> g)`
  Paints the background of the tooltip.
  `void`
  `paintComponent(Graphics g)`
  `void`
  `paintText(TGraphics<Color,Font> g)`
  Paints the values and the labels of the tooltip.
  `void`
  `setNode(N node)`
  Sets the current node that the tooltip should display information about.
  `void`
  `setPreferredWidth(int width)`
  Sets the preferred width of the tooltip.
  `void`
  `setRedispatchMouseEvent(boolean redispatchMouseEvent)`
  Controls whether the mouse event on the tooltip should be redispatched to the TreeMapView.
  `void`
  `setRenderer(ToolTipTreePlotRenderer renderer)`
  `void`
  `setSize(Dimension d)`
  `void`
  `setType(TreeMapToolTip.ToolTipType type)`
  Sets the type of the tooltip.
  `void`
  `showNode(N node)`
  Shows the current node that the tooltip should display information about.
  `protected void`
  `showPopup(int x, int y)`
  Shows the popup at the specified x and y coordinates.

  ### Methods inherited from class javax.swing.JComponent

  `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getUI, getUIClassID, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintImmediately, paintImmediately, paramString, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update, updateUI`

  ### Methods inherited from class java.awt.Container

  `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

  ### Methods inherited from class java.awt.Component

  `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, disableInputMethodSupport, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAccessibleContext, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.treemap.TreeMapToolTip

  `getHeight, getWidth`

- ## Constructor Details

  - ### SwingTreePlotToolTip

    public SwingTreePlotToolTip(SwingTreePlotView<N,Row,Column> view)

- ## Method Details

  - ### setSize

    public void setSize(Dimension d)
    Specified by:
      `setSize` in interface `TreeMapToolTip<N,Row,Column,Color,Font>`

  - ### setRedispatchMouseEvent

    public void setRedispatchMouseEvent(boolean redispatchMouseEvent)
    Controls whether the mouse event on the tooltip should be redispatched to the TreeMapView.
    Parameters:
      `redispatchMouseEvent` - true to redispatch all the mouse events, false otherwise.

  - ### paintComponent

    public void paintComponent(Graphics g)
    Overrides:
      `paintComponent` in class `JComponent`

  - ### paintText

    public void paintText(TGraphics<Color,Font> g)
    Paints the values and the labels of the tooltip.
    Specified by:
      `paintText` in interface `TreeMapToolTip<N,Row,Column,Color,Font>`
    Parameters:
      `g` - a Graphics2D object.

  - ### paintBackground

    public void paintBackground(TGraphics<Color,Font> g)
    Paints the background of the tooltip.
    Specified by:
      `paintBackground` in interface `TreeMapToolTip<N,Row,Column,Color,Font>`
    Parameters:
      `g` - a Graphis2D object.

  - ### getBorderColor

    protected com.macrofocus.igraphics.CPColor<Color> getBorderColor()

  - ### getBorder

    public Border getBorder()
    Overrides:
      `getBorder` in class `JComponent`

  - ### getInsets

    public Insets getInsets()
    Overrides:
      `getInsets` in class `JComponent`

  - ### getView

    protected SwingTreePlotView<N,Row,Column> getView()
    Gets the view associated with this tooltip.
    Returns:
      the view.

  - ### getRenderer

    public ToolTipTreePlotRenderer getRenderer()

  - ### setRenderer

    public void setRenderer(ToolTipTreePlotRenderer renderer)

  - ### getNode

    public N getNode()
    Gets the current node that the tooltip should display information about.
    Specified by:
      `getNode` in interface `TreeMapToolTip<N,Row,Column,Color,Font>`
    Returns:
      the current node.

  - ### setNode

    public void setNode(N node)
    Sets the current node that the tooltip should display information about.
    Specified by:
      `setNode` in interface `TreeMapToolTip<N,Row,Column,Color,Font>`
    Parameters:
      `node` - the node to dislay information about.

  - ### showNode

    public void showNode(N node)
    Description copied from interface: `TreeMapToolTip`
    Shows the current node that the tooltip should display information about.
    Specified by:
      `showNode` in interface `TreeMapToolTip<N,Row,Column,Color,Font>`
    Parameters:
      `node` - the node to dislay information about.

  - ### getPopupLocation

    public com.macrofocus.geom.Point getPopupLocation()
    Specified by:
      `getPopupLocation` in interface `TreeMapToolTip<N,Row,Column,Color,Font>`

  - ### getPreferredLocation

    public com.macrofocus.geom.Point getPreferredLocation()
    Gets the preferred location of the tooltip relative to the TreeMapView.
    Specified by:
      `getPreferredLocation` in interface `TreeMapToolTip<N,Row,Column,Color,Font>`
    Returns:
      the preferred location

  - ### getPreferredLocation

    public com.macrofocus.geom.Point getPreferredLocation(com.macrofocus.geom.Point p)
    Gets the preferred location of the tooltip relative to the TreeMapView.
    Parameters:
      `p` - the position of the mouse.
    Returns:
      the preferred location.

  - ### getPreferredSize

    public Dimension getPreferredSize(TGraphics<Color,Font> g)
    Specified by:
      `getPreferredSize` in interface `TreeMapToolTip<N,Row,Column,Color,Font>`
    Parameters:
      `g` -

  - ### getType

    public TreeMapToolTip.ToolTipType getType()
    Gets the type of tooltip.
    Specified by:
      `getType` in interface `TreeMapToolTip<N,Row,Column,Color,Font>`
    Returns:
      the type of the tooltip.

  - ### setType

    public void setType(TreeMapToolTip.ToolTipType type)
    Sets the type of the tooltip.
    Specified by:
      `setType` in interface `TreeMapToolTip<N,Row,Column,Color,Font>`
    Parameters:
      `type` - the tooltip type.

  - ### getPreferredWidth

    public int getPreferredWidth()
    Gets the preferred width of the tooltip.
    Specified by:
      `getPreferredWidth` in interface `TreeMapToolTip<N,Row,Column,Color,Font>`
    Returns:
      the preferred width.

  - ### setPreferredWidth

    public void setPreferredWidth(int width)
    Sets the preferred width of the tooltip.
    Specified by:
      `setPreferredWidth` in interface `TreeMapToolTip<N,Row,Column,Color,Font>`
    Parameters:
      `width` - the preferred width.

  - ### getPopup

    public TreeMapPopup getPopup()
    Gets the popup or create one if one doesn't exist yet.
    Returns:
      a JidePopup component.

  - ### showPopup

    protected void showPopup(int x, int y)
    Shows the popup at the specified x and y coordinates.
    Parameters:
      `x` - the x position. It is screen position.
      `y` - the y position. It is screen position.

  - ### hidePopup

    protected void hidePopup()
    Hides the popup.

  - ### createPopup

    protected TreeMapPopup createPopup()
    Creates a popup.
    Returns:
      a JidePopup component.

  - ### getNativeComponent

    public Component getNativeComponent()